package com.jasamedika.medifirst2000.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.stereotype.Service;

import com.jasamedika.medifirst2000.converter.PeranConverter;
import com.jasamedika.medifirst2000.dao.PeranDao;
import com.jasamedika.medifirst2000.entities.Peran;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.PeranService;
import com.jasamedika.medifirst2000.vo.PeranVO;

@Service("PeranService")
public class PeranServiceImpl extends BaseVoServiceImpl implements PeranService{

	@Autowired
	private PeranDao peranDao;
	
	@Autowired
	private PeranConverter peranConverter;
	
	@Override
	public PeranVO add(PeranVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public PeranVO update(PeranVO vo) throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Boolean delete(Integer key) throws JpaSystemException {
		return null;
	}

	@Override
	public PeranVO findById(Integer key) throws JpaSystemException {
		return null;
	}

	@Override
	public List<PeranVO> findAll() throws JpaSystemException {
		return null;
	}

	@Override
	public Map<String, Object> findAllWithPageAndLimitAndSortByAndDirectionParameter(Integer page, Integer limit,
			String sort, String dir) {
		return null;
	}

	@Override
	public Map<String, Object> findAll(Integer page, Integer take, String sort, String dir, Specification<Peran> spec) {
		Direction direction=null;
		
		if(dir.equalsIgnoreCase("asc")){
			direction=Sort.Direction.ASC;
		}else{
			direction=Sort.Direction.DESC;
		}
		
		Pageable pageable = new PageRequest(page, take, direction, sort);
		Page<Peran> resultPage = peranDao.findAll(spec, pageable);
		List<Peran> resultData = resultPage.getContent();
		return constructMapReturn(resultData, resultPage.getTotalElements(), resultPage.getTotalPages());
	}

	@Override
	public Map<String, Object> save(PeranVO vo) {
		Map<String,Object> result = new HashMap<String,Object>();
		Peran model = peranConverter.transferVOToModel(vo, new Peran());
		
		peranDao.save(model);
		
		return result;
	}

}
